;---------------------------------------------------------------------------------
; DODS 5.1 installation script
;	All output messages will be written to file ..\log.txt
;---------------------------------------------------------------------------------

!define MUI_PRODUCT "DODS ${VERSION}" ;Define your own software name here
!define MUI_VERSION "${VERSION}" ;Define your own software version here

!include "${NSISDIR}\Contrib\Modern UI\SystemDODS.nsh"
;---------------------------------------------------------------------------------
;Configuration
;---------------------------------------------------------------------------------
  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_DIRECTORYPAGE
  
  !define MUI_ABORTWARNING

  !define MUI_CUSTOMPAGECOMMANDS
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define TEMP1 $R0
  !define TEMP2 $R1
    
# Language
  !insertmacro MUI_LANGUAGE "English"
  !insertmacro MUI_LANGUAGE "German"
  !insertmacro MUI_LANGUAGE "SimpChinese"
  !insertmacro MUI_LANGUAGE "TradChinese"    
  !insertmacro MUI_LANGUAGE "Japanese"    

# General
  OutFile "..\..\..\..\distribution\Windows\DODS-${VERSION}.setup.exe"

# Install Options pages
# LANG_ENGLISH
# Header
    LangString TEXT_IO_TITLE ${LANG_ENGLISH} "Set Java home directory"
    LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Choose J2SDK 1.4.x Directory"
# Window titles
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_ENGLISH} "Click button on right side to set J2SDK 1.4.x Directory"
    LangString TEXT_IO_PAGETITLE_A ${LANG_ENGLISH} ": Set Java Home Directory"
    LangString TEXT_IO_TITLE_A ${LANG_ENGLISH} "${MUI_PRODUCT} Setup: Set Java home directory"
    LangString TEXT_IO_CANCEL_A ${LANG_ENGLISH} "&Cancel"
    LangString TEXT_IO_NEXT_A ${LANG_ENGLISH} "&Next >"
    LangString TEXT_IO_BACK_A ${LANG_ENGLISH} "< &Back"
# LANG_GERMAN
# Header
    LangString TEXT_IO_TITLE ${LANG_GERMAN} "Festes Java Heim Verzeichnis"
    LangString TEXT_IO_SUBTITLE ${LANG_GERMAN} "Whlen Sie J2SDK 1.4.x Verzeichnis"
# Window titles
    LangString TEXT_IO_PAGETITLE_A ${LANG_GERMAN} ": Festes Java Heim Verzeichnis"
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_GERMAN} "Klicken Knopf auf richtiger Seite, J2SDK 1.4.x Verzeichnis zu setzen"
    LangString TEXT_IO_TITLE_A ${LANG_GERMAN} "${MUI_PRODUCT} Installation: Festes Java Heim Verzeichnis"
    LangString TEXT_IO_CANCEL_A ${LANG_GERMAN} "Abbrechen"
    LangString TEXT_IO_NEXT_A ${LANG_GERMAN} "&Annehmen >"
    LangString TEXT_IO_BACK_A ${LANG_GERMAN} "< &Zurck"
# LANG_SIMPCHINESE
# Header
    LangString TEXT_IO_TITLE ${LANG_SIMPCHINESE} "eAJava ?1/4"
    LangString TEXT_IO_SUBTITLE ${LANG_SIMPCHINESE} "N!nJ2SDK 1.4.x ?1/4"
# Window titles
    LangString TEXT_IO_PAGETITLE_A ${LANG_SIMPCHINESE} ": eAJava ?1/4"
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_SIMPCHINESE} "AYOeAJ2SDK 1.4.x ?1/4"
    LangString TEXT_IO_TITLE_A ${LANG_SIMPCHINESE} "${MUI_PRODUCT} װ: eAJava ?1/4"
    LangString TEXT_IO_CANCEL_A ${LANG_SIMPCHINESE} "ȡ(&C)"
    LangString TEXT_IO_NEXT_A ${LANG_SIMPCHINESE} "һ(&N) >"
    LangString TEXT_IO_BACK_A ${LANG_SIMPCHINESE} "< һ(&P)"
# LANG_TRADCHINESE
# Header
    LangString TEXT_IO_TITLE ${LANG_TRADCHINESE} "]mJava Dؿ"
    LangString TEXT_IO_SUBTITLE ${LANG_TRADCHINESE} "?i3/4J2SDK 1.4.x ؿ"
# Window titles
    LangString TEXT_IO_PAGETITLE_A ${LANG_TRADCHINESE} ": ]mJava Dؿ"
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_TRADCHINESE} "Isbk]mJ2SDK 1.4.x ؿ"
    LangString TEXT_IO_TITLE_A ${LANG_TRADCHINESE} "${MUI_PRODUCT} w: ]mJava Dؿ"
    LangString TEXT_IO_CANCEL_A ${LANG_TRADCHINESE} "(&C)"
    LangString TEXT_IO_NEXT_A ${LANG_TRADCHINESE} "U@B(&N) >"
    LangString TEXT_IO_BACK_A ${LANG_TRADCHINESE} "< W@B(&P)"
# LANG_JAPANESE
# Header
    LangString TEXT_IO_TITLE ${LANG_JAPANESE} "W̃z[fBNgZbgȂ"
    LangString TEXT_IO_SUBTITLE ${LANG_JAPANESE} "J2SDK 1.4.x ̃fBNg['I'Ȃ"
# Window titles
    LangString TEXT_IO_PAGETITLE_A ${LANG_JAPANESE} ": W̃z[fBNgZbgȂ"
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_JAPANESE} "J2SDK 1.4.x ̃fBNg[ZbgE'̃NbN{^"
    LangString TEXT_IO_TITLE_A ${LANG_JAPANESE} "${MUI_PRODUCT} ZbgAbv: W̃z[fBNgZbgȂ"
    LangString TEXT_IO_CANCEL_A ${LANG_JAPANESE} "LZ"
    LangString TEXT_IO_NEXT_A ${LANG_JAPANESE} "(&N) >"
    LangString TEXT_IO_BACK_A ${LANG_JAPANESE} "< ߂(&B)"
  
# Page order 
	!insertmacro MUI_PAGECOMMAND_WELCOME
	!insertmacro MUI_PAGECOMMAND_LICENSE
  Page custom SetCustomPage "$(TEXT_IO_PAGETITLE_A)" ; call page to choose java home directory
  !insertmacro MUI_PAGECOMMAND_DIRECTORY
  !insertmacro MUI_PAGECOMMAND_INSTFILES
  
# License page (only on English language)
  LicenseData /LANG=${LANG_ENGLISH} "${NSISDIR}\Contrib\License\LicenseEnglish.txt"
  LicenseData /LANG=${LANG_GERMAN} "${NSISDIR}\Contrib\License\LicenseGerman.txt"
  LicenseData /LANG=${LANG_SIMPCHINESE} "${NSISDIR}\Contrib\License\LicenseSimpChinese.txt"
  LicenseData /LANG=${LANG_TRADCHINESE} "${NSISDIR}\Contrib\License\LicenseTradChinese.txt"
  LicenseData /LANG=${LANG_JAPANESE} "${NSISDIR}\Contrib\License\LicenseJapanese.txt"

# Component-selection page
    ;Titles
    LangString TITLE_SecCopyUI ${LANG_ENGLISH} "DODS"
    LangString TITLE_SecCopyUI ${LANG_GERMAN} "DODS"
    LangString TITLE_SecCopyUI ${LANG_SIMPCHINESE} "DODS"
    LangString TITLE_SecCopyUI ${LANG_TRADCHINESE} "DODS"
    LangString TITLE_SecCopyUI ${LANG_JAPANESE} "DODS"

# Folder-selection page
  InstallDir "C:\DODS${VERSION}"
  
# Things that need to be extracted on startup (keep these lines before any File command!)
# Only useful for BZIP2 compression
# Use ReserveFile for your own Install Options ini files too!
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "dods.ini"
;---------------------------------------------------------------------------------
;Modern UI System
;---------------------------------------------------------------------------------
!insertmacro MUI_SYSTEM
;---------------------------------------------------------------------------------
;Installer Sections
;---------------------------------------------------------------------------------
Section $(TITLE_SecCopyUI) SecCopyUI

  SetOutPath "$INSTDIR"
  File /r "..\..\DODSWindowsInstall\*.*"
	  
  ; $1 = [Field 2] state
  !insertmacro MUI_INSTALLOPTIONS_READ $1 "dods.ini" "Field 2" "State" ; read choosed java 

  ; replace char '\' with char '/' at JDK directory string
  Push "$1"
  Push "\"
  Push "/"
	Call ReplaceChar
	Pop $1

#	CopyFiles "$7" "$INSTDIR\build.properties"	; copy file build.properties to installation directory

	; set value for jdk.dir in file build.properties
	FileOpen $8 $INSTDIR\build.properties w
	FileWrite $8 "jdk.dir=$1"
	FileWriteByte $8 13


  ClearErrors
  ExecWait '"$INSTDIR\configure.bat"' $0	; start configuring DODS

	StrCmp $0 "0" success1
	DetailPrint "${MUI_PRODUCT} installation failed (output: $0)"
	Goto end

	success1:
	DetailPrint "${MUI_PRODUCT} installation succeded (output: $0)"

  Push "$INSTDIR\bin"
  Call AddToPath ; Add $INSTDIR\bin to PATH enviroment variable

  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\${MUI_PRODUCT}" "Install_Dir" "$INSTDIR"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM 	"Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" \
  									"DisplayName" "${MUI_PRODUCT} (remove only)"
  WriteRegStr HKLM 	"Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" \
  									"UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"

	; Create Start Menu Shortcuts
  CreateDirectory "$SMPROGRAMS\${MUI_PRODUCT}"

  
  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\ DODS Quick start.lnk" \
                 "$INSTDIR\doc\dods\using_dods.html" \
                 "" \
                 "$INSTDIR\images\dodsdemo.ico" 0
#  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Readme.lnk" \
#                 "$INSTDIR\readme.txt" \
#                 "" \
#                 "$WINDIR\notepad.exe"
#  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Start MultiServer in a Console.lnk" \
#                 "$INSTDIR\bin\multiserver.bat" \
#                 "" \
#                 "$INSTDIR\images\multiserver.ico" 0
#  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Install MultiServer as Windows system service.lnk" \
#                 "$INSTDIR\util\wrapper\dods\java_service_install.bat" \
#                 "" \
#                 "$INSTDIR\images\multiserver7.ico" 0
#  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Start MultiServer Windows system service.lnk" \
#                 "$INSTDIR\util\wrapper\dods\java_service_start.bat" \
#                 "" \
#                 "$INSTDIR\images\multiserver5.ico" 0
#  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Stop MultiServer Windows system service.lnk" \
#                 "$INSTDIR\util\wrapper\dods\java_service_stop.bat" \
#                 "" \
#                 "$INSTDIR\images\multiserver2.ico" 0
#  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Remove MultiServer from Windows system service.lnk" \
#                 "$INSTDIR\util\wrapper\dods\java_service_remove.bat" \
#                 "" \
#                 "$INSTDIR\images\multiserver6.ico" 0
#  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Application Wizard.lnk" \
#                 "$INSTDIR\bin\appwizard.bat" \
#                 "" \
#                 "$INSTDIR\images\wizard.ico" 0
  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\DODS.lnk" \
                 "$INSTDIR\bin\dods.bat" \
                 "" \
                 "$INSTDIR\images\dods.ico" 0
#  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Demos.lnk" \
#                 "$PROGRAMFILES\Internet Explorer\iexplore.exe" \
#                 "http://localhost:9050/demoApp" \
#                 "$INSTDIR\images\dodsdemo.ico" 0
  CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Uninstall.lnk" \
                 "$INSTDIR\uninstall.exe" \
                 "" \
                 "$INSTDIR\uninstall.exe" 0

#	; Create Desktop Shortcuts
#  CreateShortCut "$DESKTOP\DODS Quick Start.lnk" \
#                 "$INSTDIR\doc\DODS_quick_start.htm" \
#                 "" \
#                 "$INSTDIR\images\dods-install.ico" 0

	end:
  ;Write language to the registry (for the uninstaller)
  WriteRegStr HKCU "Software\${MUI_PRODUCT}" "Installer Language" $LANGUAGE
  WriteUninstaller "$INSTDIR\Uninstall.exe"

SectionEnd
;---------------------------------------------------------------------------------
;Installer Functions
;---------------------------------------------------------------------------------
Function .onInit

# start splash screen
# the plugins dir is automatically deleted when the installer exits
		InitPluginsDir
		File /oname=$PLUGINSDIR\splash.bmp "${NSISDIR}\Modern UI\welcome.bmp"
# optional sound
#File /oname=$PLUGINSDIR\splash.wav "C:\myprog\sound.wav"
		advsplash::show 1000 600 400 -1 $PLUGINSDIR\splash
		Pop $0 ; $0 has '1' if the user closed the splash screen early,
		                ; '0' if everything closed normal, and '-1' if some error occured.
# end splash screen

  ;Extract Install Options INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "dods.ini"

# start Language selection
# Font
  Push Tahoma
  Push 8

# Languages
  !insertmacro MUI_LANGDLL_PUSH "English"
  !insertmacro MUI_LANGDLL_PUSH "German"
  !insertmacro MUI_LANGDLL_PUSH "SimpChinese"
  !insertmacro MUI_LANGDLL_PUSH "TradChinese"    
  !insertmacro MUI_LANGDLL_PUSH "Japanese"    
  
  Push 5F ;5 = number of languages, F = change font

  LangDLL::LangDialog "Installer Language" "Please select a language."

  Pop $LANGUAGE
  StrCmp $LANGUAGE "cancel" 0 +2
  Abort
# end Language selection

FunctionEnd
;---------------------------------------------------------------------------------
; Call when installation success
;---------------------------------------------------------------------------------
Function .onInstSuccess
#	Call RunMultiServerService
	Call RunDODSQuickStart
FunctionEnd
;---------------------------------------------------------------------------------
; Descriptions
;---------------------------------------------------------------------------------
!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
!insertmacro MUI_DESCRIPTION_TEXT ${SecCopyUI} $(DESC_SecCopyUI)
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END
;---------------------------------------------------------------------------------
;Uninstaller Section
;---------------------------------------------------------------------------------
Section "Uninstall"

#	Call un.MultiServerService  ; uninstall MultiServer service
	
  Push "$INSTDIR\bin"
  Call un.RemoveFromPath ;remove $INSTDIR\bin from PATH enviroment variable

  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"
  DeleteRegKey HKLM "SOFTWARE\${MUI_PRODUCT}"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${MUI_PRODUCT}\*.*"
#  Delete "$DESKTOP\DODS Quick Start.lnk"

  ; remove directories used.
  RMDir "$SMPROGRAMS\${MUI_PRODUCT}"
  RMDir /r "$INSTDIR"

SectionEnd
;---------------------------------------------------------------------------------
;Uninstaller Functions
;---------------------------------------------------------------------------------
#Function un.onInit
#
#  ;Get language from registry
#  ReadRegStr $LANGUAGE HKCU "Software\${MUI_PRODUCT}" "Installer Language"
#
#	MessageBox MB_YESNO|MB_ICONQUESTION|MB_TOPMOST \
#	"If  DODS ${VERSION} MultiServer is started as a system service, stop and remove it, and then start uninstall again. Continue uninstall ?" \
#	IDYES continue
#	Abort "Uninstall aborted by user"
#	
#	continue:
#  
#FunctionEnd
;------------------------------------------------------------------------------
; ReplaceChar
; input, input string  (C:\JBuilder\jdk1.3.1)
;        char to need replaced (\)
;        char to with replaced (/)
; output, top of stack (C:/JBuilder/jdk1.3.1)
; modifies no other variables.
;
; Usage:
;   Push $1 ; "C:\JBuilder\jdk1.3.1"
;   Push "\"
;   Push "/"
;   Call ReplaceChar
;   Pop $0
;   ; at this point $0 will equal "C:/JBuilder/jdk1.3.1"
;------------------------------------------------------------------------------
Function ReplaceChar
					; stack="/","\","C:\JBuilder\jdk1.3.1", ... (from top to down)
  Exch $2 ; $2="/", stack="2-gi param","\","C:\JBuilder\jdk1.3.1", ...
  Exch  	; stack="\","2-ti param","C:\JBuilder\jdk1.3.1", ...
  Exch $1 ; $1="\", stack="1-vi param","2-gi param","C:\JBuilder\jdk1.3.1", ...
  Exch    ; stack="2-gi param","1-vi param","C:\JBuilder\jdk1.3.1", ...
	Exch 2	; stack="C:\JBuilder\jdk1.3.1","1-vi param","2-gi param", ...
  Exch $0 ; $0="C:\JBuilder\jdk1.3.1", stack="0-ti param","1-vi param","2-gi param", ...
  Exch 2  ; stack="2-gi param","1-vi param","0-ti param", ...

  Push $3	; Len("C:\JBuilder\jdk1.3.1")
  Push $4	; index of string
  Push $5 ; tmp - form strat to found char witch need to change
  Push $6 ; tmp - from found char witch need to change + 1 to end ($3)
  Push $7 ; tmp - position where found char witch need to change + 1
  StrLen $3 $0
  StrCpy $4 1
  loop:
    StrCpy $5 $0 1 $4
    StrCmp $5 "" exit
    StrCmp $5 $1 change
    IntOp $4 $4 + 1
  Goto loop
  change:
  	StrCpy $6 $4				; pozition where found char witch need to change
  	StrCpy $5 $0 $6   	; $5="C:"
  	StrCpy $5 "$5$2"   	; $5="C:/"
  	StrCpy $7 $4				; pozition where found char witch need to change
  	IntOp $7 $7 + 1 		; next pozition
  	StrCpy $6 $0 $3 $7  ; $6="JBuilder\jdk1.3.1"
  	StrCpy $0 $5				; $0="C:/"
  	StrCpy $0 "$0$6" 		; $0="C:/JBuilder\jdk1.3.1"
  Goto loop
  exit:
    Pop $7
    Pop $6
    Pop $5
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;------------------------------------------------------------------------------
; GetParent
; input, top of stack  (i.e. C:\Program Files\Poop)
; output, top of stack (replaces, with i.e. C:\Program Files)
; modifies no other variables.
;
; Usage:
;   Push "C:\Program Files\Directory\Whatever"
;   Call GetParent
;   Pop $0
;   ; at this point $0 will equal "C:\Program Files\Directory"
;------------------------------------------------------------------------------
#Function GetParent
#  Exch $0 ; old $0 is on top of stack
#  Push $1
#  Push $2
#  StrCpy $1 -1
#  loop:
#    StrCpy $2 $0 1 $1
#    StrCmp $2 "" exit
#    StrCmp $2 "\" exit
#    IntOp $1 $1 - 1
#  Goto loop
#  exit:
#    StrCpy $0 $0 $1
#    Pop $2
#    Pop $1
#    Exch $0 ; put $0 on top of stack, restore $0 to original value
#FunctionEnd
;------------------------------------------------------------------------------
; Run MultiServer as Windows service
;------------------------------------------------------------------------------
#Function RunMultiServerService
#
#	MessageBox MB_YESNO  "Would you like to install and start MultiServer as Windows Service ?!" IDYES RunService
#	Goto end
#
#	RunService:
#  ClearErrors
#
#  ExecWait '"$INSTDIR\util\wrapper\dods\java_service_run.bat"' $0	; start configuring DODS
#
#	StrCmp $0 "0" success
#	DetailPrint "Running DODS MultiServer as Windows system service FAILED (output: $0)"
#	Goto end
#	
#	success:
#	DetailPrint "Running DODS MultiServer as Windows system service succeded (output: $0)"
#
#	end:
#FunctionEnd
;------------------------------------------------------------------------------
; Run DODS Quick Start
;------------------------------------------------------------------------------
Function RunDODSQuickStart

	MessageBox MB_YESNO  "Would you like to start DODS Quick Start ?!" IDYES Read
	Goto end

	Read:
  ExecShell "open" '"$INSTDIR\doc\dods\using_dods.html"'

	end:
FunctionEnd
;------------------------------------------------------------------------------
; Page to choose java home directory
;------------------------------------------------------------------------------
Function SetCustomPage

	start:

	Call IfJavaExist ; check if JAVA_HOME directory exist

  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE)" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "dods.ini"

   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end

  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP1} "dods.ini" "Field 2" "State"

	IfFileExists ${TEMP1}\bin\java.exe continue	; check if java.exe exist
	MessageBox MB_OK "File java.exe does not exist in directory ${TEMP1}\bin"
	Goto start
		
	continue:
	IfFileExists ${TEMP1}\bin\javac.exe checkJDK	; check if javac.exe exist
	MessageBox MB_OK "File javac.exe does not exist in directory ${TEMP1}\bin"
	Goto start

	checkJDK:
	IfFileExists ${TEMP1}\jre\lib\jsse.jar end	; check if JDK 1.4.x
	MessageBox MB_OK "File jsse.jar does not exist in directory ${TEMP1}\jre\lib"
	Goto start

	end:
FunctionEnd
;------------------------------------------------------------------------------
; Check if choosed java home directory
;------------------------------------------------------------------------------
Function IfJavaExist

  !insertmacro MUI_INSTALLOPTIONS_WRITE "dods.ini" "Settings" "Title" "$(TEXT_IO_TITLE_A)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "dods.ini" "Field 1" "Text" "$(TEXT_IO_PAGESUBTITLE_A)"
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP1} "dods.ini" "Field 2" "State"

  !insertmacro MUI_INSTALLOPTIONS_WRITE "dods.ini" "Settings" "CancelButtonText" "$(TEXT_IO_CANCEL_A)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "dods.ini" "Settings" "NextButtonText" "$(TEXT_IO_NEXT_A)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "dods.ini" "Settings" "BackButtonText" "$(TEXT_IO_BACK_A)"

    ReadRegStr $1 HKLM "SOFTWARE\JavaSoft\Java Development Kit" "CurrentVersion"
	ReadRegStr $2 HKLM "SOFTWARE\JavaSoft\Java Development Kit\$1" "JavaHome"
    StrCmp $2 "" end

	StrCpy $3 $1 1 ; major version
  StrCpy $4 $1 1 2 ; minor version
  IntFmt $5 "%u" $3
  IntFmt $6 "%u" $4    
  IntCmp $6 4  0 end

	IfFileExists $2\bin\javac.exe "" end	; check if javac.exe exist
	IfFileExists $2\jre\lib\jsse.jar OK	; check if jsse.jar exist
	Goto end

	OK:
  !insertmacro MUI_INSTALLOPTIONS_WRITE "dods.ini" "Field 2" "State" "$2"
	
	end:
FunctionEnd
;------------------------------------------------------------------------------
; Call on installation failed
;------------------------------------------------------------------------------
Function .onInstFailed
	MessageBox MB_OK ".onInstFailed"
	Call Cleanup
FunctionEnd
;------------------------------------------------------------------------------
; Call when installation failed or when uninstall started
;------------------------------------------------------------------------------
Function Cleanup

  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"
  DeleteRegKey HKLM "SOFTWARE\${MUI_PRODUCT}"
  ; MUST REMOVE UNINSTALLER, too
  Delete "$INSTDIR\Uninstall.exe"
  ; remove directories used.
  RMDir /r "$INSTDIR"

FunctionEnd
;------------------------------------------------------------------------------
; Uninstall MultiServer Windows service
;------------------------------------------------------------------------------
#Function un.MultiServerService
#
#  ExecWait '"$INSTDIR\util\wrapper\bin\Wrapper.exe" "-r" "$INSTDIR\util\wrapper\dods\wrapper_dods.conf"' $0	; uninstall DODSMultiserver service
#  ExecWait '"$INSTDIR\util\wrapper\dods\EnTray.exe" "uninstall"' $0
#
#FunctionEnd
;-------------------- novo ---------------------------------------------------------------------
;====================================================
; AddToPath - Adds the given dir to the search path.
;        Input - head of the stack
;        Note - Win9x systems requires reboot
;====================================================
Function AddToPath
  Exch $0
  Push $1
  
  Call IsNT
  Pop $1
  StrCmp $1 1 AddToPath_NT
    ; Not on NT
    StrCpy $1 $WINDIR 2
    FileOpen $1 "$1\autoexec.bat" a
    FileSeek $1 0 END
    GetFullPathName /SHORT $0 $0
    FileWrite $1 "$\r$\nSET PATH=$0;%PATH%$\r$\n"
    FileClose $1
    Goto AddToPath_done

  AddToPath_NT:
    ReadRegStr $1 HKCU "Environment" "PATH"
    StrCmp $1 "" AddToPath_NTdoIt
      StrCpy $0 "$0;$1"
      Goto AddToPath_NTdoIt
    AddToPath_NTdoIt:
      WriteRegStr HKCU "Environment" "PATH" $0
      SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000
  
  AddToPath_done:
    Pop $1
    Pop $0
FunctionEnd

;====================================================
; RemoveFromPath - Remove a given dir from the path
;     Input: head of the stack
;====================================================
Function un.RemoveFromPath
  Exch $0
  Push $1
  Push $2
  Push $3
  Push $4
  
  Call un.IsNT
  Pop $1
  StrCmp $1 1 unRemoveFromPath_NT
    ; Not on NT
    StrCpy $1 $WINDIR 2
    FileOpen $1 "$1\autoexec.bat" r
    GetTempFileName $4
    FileOpen $2 $4 w
    GetFullPathName /SHORT $0 $0
    StrCpy $0 "SET PATH=$0;%PATH%"
    SetRebootFlag true
    Goto unRemoveFromPath_dosLoop
    
    unRemoveFromPath_dosLoop:
      FileRead $1 $3
      StrCmp $3 "$0$\r$\n" unRemoveFromPath_dosLoop
      StrCmp $3 "$0$\n" unRemoveFromPath_dosLoop
      StrCmp $3 "$0" unRemoveFromPath_dosLoop
      StrCmp $3 "" unRemoveFromPath_dosLoopEnd
      FileWrite $2 $3
      Goto unRemoveFromPath_dosLoop
    
    unRemoveFromPath_dosLoopEnd:
      FileClose $2
      FileClose $1
      StrCpy $1 $WINDIR 2
      Delete "$1\autoexec.bat"
      CopyFiles /SILENT $4 "$1\autoexec.bat"
      Delete $4
      Goto unRemoveFromPath_done

  unRemoveFromPath_NT:
    StrLen $2 $0
    ReadRegStr $1 HKCU "Environment" "PATH"
    Push $1
    Push $0
    Call un.StrStr ; Find $0 in $1
    Pop $0 ; pos of our dir
    IntCmp $0 -1 unRemoveFromPath_done
      ; else, it is in path
      StrCpy $3 $1 $0 ; $3 now has the part of the path before our dir
      IntOp $2 $2 + $0 ; $2 now contains the pos after our dir in the path (';')
      IntOp $2 $2 + 1 ; $2 now containts the pos after our dir and the semicolon.
      StrLen $0 $1
      StrCpy $1 $1 $0 $2
      StrCpy $3 "$3$1"

      WriteRegStr HKCU "Environment" "PATH" $3
      SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000
  
  unRemoveFromPath_done:
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Pop $0
FunctionEnd

;====================================================
; StrStr - Finds a given string in another given string.
;               Returns -1 if not found and the pos if found.
;          Input: head of the stack - string to find
;                      second in the stack - string to find in
;          Output: head of the stack
;====================================================
#Function StrStr
#  Push $0
#  Exch
#  Pop $0 ; $0 now have the string to find
#  Push $1
#  Exch 2
#  Pop $1 ; $1 now have the string to find in
#  Exch
#  Push $2
#  Push $3
#  Push $4
#  Push $5
#
#  StrCpy $2 -1
#  StrLen $3 $0
#  StrLen $4 $1
#  IntOp $4 $4 - $3
#
#  StrStr_loop:
#    IntOp $2 $2 + 1
#    IntCmp $2 $4 0 0 StrStrReturn_notFound
#    StrCpy $5 $1 $3 $2
#    StrCmp $5 $0 StrStr_done StrStr_loop
#
#  StrStrReturn_notFound:
#    StrCpy $2 -1
#
#  StrStr_done:
#    Pop $5
#    Pop $4
#    Pop $3
#    Exch $2
#    Exch 2
#    Pop $0
#    Pop $1
#FunctionEnd

;====================================================
; IsNT - Returns 1 if the current system is NT, 0
;        otherwise.
;     Output: head of the stack
;====================================================
Function IsNT
  Push $0
  ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
  StrCmp $0 "" 0 IsNT_yes
  ; we are not NT.
  Pop $0
  Push 0
  Return

  IsNT_yes:
    ; NT!!!
    Pop $0
    Push 1
FunctionEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uninstall sutff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;====================================================
; StrStr - Finds a given string in another given string.
;               Returns -1 if not found and the pos if found.
;          Input: head of the stack - string to find
;                      second in the stack - string to find in
;          Output: head of the stack
;====================================================
Function un.StrStr
  Push $0
  Exch
  Pop $0 ; $0 now have the string to find
  Push $1
  Exch 2
  Pop $1 ; $1 now have the string to find in
  Exch
  Push $2
  Push $3
  Push $4
  Push $5

  StrCpy $2 -1
  StrLen $3 $0
  StrLen $4 $1
  IntOp $4 $4 - $3

  unStrStr_loop:
    IntOp $2 $2 + 1
    IntCmp $2 $4 0 0 unStrStrReturn_notFound
    StrCpy $5 $1 $3 $2
    StrCmp $5 $0 unStrStr_done unStrStr_loop

  unStrStrReturn_notFound:
    StrCpy $2 -1

  unStrStr_done:
    Pop $5
    Pop $4
    Pop $3
    Exch $2
    Exch 2
    Pop $0
    Pop $1
FunctionEnd

;====================================================
; IsNT - Returns 1 if the current system is NT, 0
;        otherwise.
;     Output: head of the stack
;====================================================
Function un.IsNT
  Push $0
  ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
  StrCmp $0 "" 0 unIsNT_yes
  ; we are not NT.
  Pop $0
  Push 0
  Return

  unIsNT_yes:
    ; NT!!!
    Pop $0
    Push 1
FunctionEnd
