/*-----------------------------------------------------------------------------
 * Enhydra Java Application Server
 * Copyright 1997-2000 Lutris Technologies, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes Enhydra software developed by Lutris
 *      Technologies, Inc. and its contributors.
 * 4. Neither the name of Lutris Technologies nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY LUTRIS TECHNOLOGIES AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL LUTRIS TECHNOLOGIES OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 * 
 * contains WebDocWf extensions
 * 
 *-----------------------------------------------------------------------------
 * C:/develop/gen/org/webdocwf/util/genericstore/data/AttributeBoolValueDO.java
 *-----------------------------------------------------------------------------
 */

package org.webdocwf.util.genericstore.data;

import java.math.BigDecimal;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.enhydra.dods.DODS;
import org.webdocwf.dods.access.AccessEvalException;
import org.webdocwf.dods.access.AccessException;
import org.webdocwf.dods.access.AccessRightException;
import org.webdocwf.util.genericstore.GenericStoreDO;

import com.lutris.appserver.server.sql.CoreDO;
import com.lutris.appserver.server.sql.DBConnection;
import com.lutris.appserver.server.sql.DBRowUpdateException;
import com.lutris.appserver.server.sql.DBTransaction;
import com.lutris.appserver.server.sql.DatabaseManager;
import com.lutris.appserver.server.sql.DatabaseManagerException;
import com.lutris.appserver.server.sql.ObjectId;
import com.lutris.appserver.server.sql.ObjectIdException;
import com.lutris.dods.builder.generator.query.DataObjectException;
import com.lutris.dods.builder.generator.query.NonUniqueQueryException;
import com.lutris.dods.builder.generator.query.QueryException;
import com.lutris.dods.builder.generator.query.RDBColumn;
import com.lutris.dods.builder.generator.query.RDBColumnValue;
import com.lutris.dods.builder.generator.query.RDBRow;
import com.lutris.dods.builder.generator.query.RDBTable;
import com.lutris.dods.builder.generator.query.RefAssertionException;
// end of WebDocWf extension for DODS row instance security and genric store

/**
 * Data core class, used to set, retrieve the AttributeBoolValueDO information.
 *
 * @version $Revision: 1.2 $
 * @author  administrator
 * @since   org
 */
 public class AttributeBoolValueDO extends org.webdocwf.util.genericstore.GenericStoreDO implements AttributeBoolValueDOI, java.io.Serializable {

    /**
     * static final data members name the table and columns for this DO.
     * By using these members with an instance of the QueryBuilder class,
     * an application can perform straight SQL queries while retaining
     * compile-time checking of table and column usage.
     *
     * Example:  List the Cities containing Persons named Bob:
     *
     *    Using straight SQL with QueryBuilder:
     *      Pro: code runs faster because you create fewer objects
     *      Con: code is less clear
     *
     *         Vector fields = new Vector();
     *         fields.addElement( AddressDO.City );
     *         QueryBuilder qb = new QueryBuilder( fields );
     *         qb.addWhere( PersonDO.FirstName, "Bob" );
     *         qb.addWhere( PersonDO.PrimaryKey, AddressDO.Person );
     *         RDBRow row;
     *         while ( null != ( row = qb.getNextRow() ) ) {
     *             String city = row.get( AddressDO.City ).getString();
     *         }
     *
     *    Using Query/DO classes:
     *      Pro: code is (often) clearer
     *      Con: code runs slower because you create more objects
     *
     *         PersonQuery pq = new PersonQuery();
     *         pq.setQueryFirstName( "Bob" );
     *         PersonDO[] bobs = pq.getDOArray();
     *         for ( int i = 0; i < bobs.length; i++ ) {
     *             AddressQuery aq = new AddressQuery();
     *             aq.setQueryPerson( bobs[i] );
     *             AddressDO addr = aq.getNextDO();
     *             String city = addr.getCity();
     *         }
     */
    static public final RDBTable  table = new RDBTable( "ATTRIBUTEBOOLVALUE" );

    /**
     * Return ATTRIBUTEBOOLVALUE as the name of the table in the database
     * which contains AttributeBoolValueDO objects.
     * This method overrides CoreDO.getTableName()
     * and is used by CoreDO.executeUpdate() during error handling.
     *
     * @return the database table name
     * @see CoreDO
     * @author Jay Gunter
     */
// WebDocWf enhancement for public tablename
// The following line has been changed
    public String getTableName() {
// before: protected String getTableName() {
	return "ATTRIBUTEBOOLVALUE";
    }

   /**
    * static final RDBColumn PrimaryKey for use with QueryBuilder.
    * See example above.
    */
    static public final RDBColumn PrimaryKey = new RDBColumn( table,
					      getPrimaryKeyName() );
    /* RDBColumns for AttributeBoolValueDO attributes are defined below. */

    /* Using a DO (and its Query class) to access a VIEW instead of a TABLE:
     *
     * A DO (and its Query class) can be used to access a VIEW
     * instead of a TABLE.  The Data Object is created as usual in DODS,
     * but the "create table" SQL command for that DO is not used.
     * Instead, you substitute a "create view" command to create a
     * virtual table in the database; this is often done to provide
     * convenient access to a collection of tables joined together.
     *
     * A VIEW usually does not return "oid" and "version" columns;
     * often (but now always) a VIEW is defined to return the "oid" column
     * for one of the tables joined together in the definition of the VIEW.
     * If the isView flag is true, AttributeBoolValueDO.createExisting(ResultSet)
     * will NOT invoke the GenericDO(ResultSet) constructor
     * so to avoid attempting to extract the "oid" and "version" columns
     * from the ResultSet.
     */
    static protected final boolean isView = false;

    /**
     * A DO class contains a reference to a DataStruct class.
     * This reference can be null (when the data for the DO
     * has not yet been retrieved from the database),
     * allowing a DO object to be a lightweight placeholder
     * until its data is needed.
     */
    private AttributeBoolValueDataStruct data = null;

    /**
     * isReadOnly()
     * Returns true if the data for this object has been marked read-only.
     */
    public boolean isReadOnly() {
	if ( null == data ) return false;
	return data.readOnly;
    }

    /**
     * Protected constructor.  Only derived classes should call it.
     *
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     */
    protected AttributeBoolValueDO ( boolean is_view )
    throws ObjectIdException, DatabaseManagerException {
        super( is_view );
    }

    /**
     * Protected constructor.  Only derived classes should call it.
     *
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     */
    protected AttributeBoolValueDO ()
    throws ObjectIdException, DatabaseManagerException {
        super( isView );
    }

    /**
     * isLoaded()
     * Returns true if the data for this objects has been retrieved
     * from the database.
     */
    public boolean isLoaded() {
	return ( null != data );
    }

    /**
     * loadData()
     * Load the fields for the DO from the database.
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    public void loadData()
    throws SQLException, ObjectIdException, DataObjectException
    {
	if ( null == data ) {
	    
	    data = new AttributeBoolValueDataStruct ();
	}

	ObjectId id = getOId();
	if ( null == id )
	    return;
	if ( ! isPersistent() )   // DO from createVirgin
	    return;

	// DO from createExisting.  Complain if no record in database.
	AttributeBoolValueQuery query = new AttributeBoolValueQuery ();
	query.setQueryOId( id );
	query.requireUniqueInstance();
	AttributeBoolValueDO obj;
	try {
	    obj = query.getNextDO();
	    if ( null == obj )
		throw new DataObjectException(
		    "AttributeBoolValueDO DO not found for id=" + id );
	    makeIdentical(obj);
	    setVersion(    obj.getVersion() );
	    setNewVersion( obj.getVersion() );

	} catch ( NonUniqueQueryException e ) {
	    throw new ObjectIdException( "Duplicate ObjectId" );
	}
// WebDocWf fix for thread safe lazy loading
// The following lines have been added:
// end of WebDocWf fix for thread safe lazy loading

    }
    /**
     * Load the actual DO data if necessary.
     * Called by get/set methods.
     *
     * @exception DataObjectException If a data access error occurs.
     */
    protected void checkLoad()
    throws DataObjectException {
	if ( null == data )
	    try {
		loadData();
	    } catch ( Exception e ) {
		throw new DataObjectException(
		    "Unable to load data for AttributeBoolValueDO id=" + getOId() +
		    ", error = " + e.getMessage() );
	    }
    }

    /**
     * Protected constructor used by createExisting(ObjectId) above.
     *
     * @param id The ObjectId for the object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   Should never see this exception since GenericDO.ctor(ObjectId)
     *   never accesses the database.
     */
    protected AttributeBoolValueDO( ObjectId id )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException
    {
	super( id );
    }




    /**
     * createVirgin()
     * Creates a DO that has no ObjectId or data.
     * Such a DO is used to insert a new database entry
     * after its data has been set.
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     */
    public static AttributeBoolValueDO createVirgin()
    throws DatabaseManagerException, ObjectIdException {
	return new AttributeBoolValueDO ();
    }
// WebDocWf extension for DODS row instance security
// The following lines have been added:
    /**
     * createVirgin()
     * Creates a DO that has no ObjectId or data.
     * Such a DO is used to insert a new database entry
     * after its data has been set.
     *
     * @param usr The user for security check
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception AccessException
     *   The user is not allowed to create new instances
     *
     * WebDocWf extension
     *
     */
    public static AttributeBoolValueDO createVirgin( org.webdocwf.dods.access.User usr )
    throws DatabaseManagerException, ObjectIdException, AccessException {
        assertDOCreateAccess( usr );
	return createVirgin();
    }
    /**
     * Ensure that the given user is allowed to create new instances
     *
     * @param usr The user for security check
     *
     * @exception AccessException
     *   The user is not allowed to create new instances
     *
     * WebDocWf extension
     *
     */
    public static void assertDOCreateAccess( org.webdocwf.dods.access.User usr )
    throws AccessException {
	if (! hasDOCreateAccess( usr )) throw new AccessRightException("No access !", usr, "Get", null, "org.webdocwf.util.genericstore.data.AttributeBoolValueDO", null, null, null, null, null);
    }
    /**
     * Check whether the given user is allowed to create new instances
     *
     * @param usr The user for security check
     * @return Whether the given user is allowed to create new instances
     *
     * WebDocWf extension
     *
     */
    public static boolean hasDOCreateAccess( org.webdocwf.dods.access.User usr )
    throws AccessEvalException
    {
      	return usr.hasDOCreateAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO" );
    }
// end of WebDocWf extension for DODS row instance security

// WebDocWf extension for generic store
// The following lines have been addded
    /**
     * Create an instance for an existing row
     * This is a strange hack for having an instance method
     * Maybe there is a better solution ?
     *
     * WebDocWf extension
     *
     */
    public GenericStoreDO createForExisting( BigDecimal bd )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException
    {
	return createExisting( bd );
    }
// end of WebDocWf extension for generic store

    /**
     * createExisting( BigDecimal )
     *
     * Factory method creates a AttributeBoolValueDO object by searching for it
     * in the database using the passed BigDecimal value as the primary key.
     *
     * Creates a DO that represents an existing entry in the database.
     * Such a DO is used to examine and possibly update such an entry.
     * createExisting() is called only from the code that retrieves
     * an ObjectId from a ResultSet (database query result).
     * createExisting() is protected because no other DO or BO should ever
     * need to call it.
     * FIX unfortunately the createExisting(BigDecimal) form *does* need
     * to be public because it is called by the public ctors of other DOs.
     * For example,
     *    AaaDO contains a ref to a BbbDO,
     *    so there is a method AaaDO.setBbb(BbbDO).
     *    In the ctor AaaDO(ResultSet), we have the call
     *       setBbb( BbbDO.createExisting( rs.getBigDecimal( "bbb", 0 )));
     * Since AaaDO is not in the same package as BbbDO,
     * BbbDO.createExisting(BigDecimal) must be public, not protected.
     * Java needs the C++ 'friend' idea.
     *
     * @param bd The BigDecimal representation of the ObjectId for the object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    public static AttributeBoolValueDO createExisting( BigDecimal bd )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException
    {
	if ( null == bd )
	    return null;
	return createExisting( new ObjectId( bd ) );
    }
// WebDocWf extension for DODS row instance security
// The following lines have been added:
    /**
     * createExisting( BigDecimal )
     *
     * Factory method creates a AttributeBoolValueDO object by searching for it
     * in the database using the passed BigDecimal value as the primary key.
     *
     * @param bd The BigDecimal representation of the ObjectId for the object.
     * @param usr The user for security check
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     * @exception AccessException
     *   The user is not allowed to read the instance existance
     *   
     * WebDocWf extension
     *   
     */
    public static AttributeBoolValueDO createExisting( BigDecimal bd, org.webdocwf.dods.access.User usr )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException, AccessException
    {
	if ( null == bd )
	    return null;
	AttributeBoolValueDO ret = createExisting( new ObjectId( bd ) );
	ret.assertDOGetAccess( usr );
	return ret;
    }
    /**
     * Check whether the given user is allowed to read the DO existance
     * Static function to be called without having the object
     *
     * @param bd The BigDecimal representation of the ObjectId for the object.
     * @param usr The user for security check
     * @return Whether the given user is allowed to read the DO existance
     *   
     * WebDocWf extension
     *   
     */
    public static boolean hasDOGetAccess( BigDecimal bd, org.webdocwf.dods.access.User usr ) 
    throws AccessEvalException
    {
	AttributeBoolValueDO newDO;
	try {
	  newDO = createExisting( new ObjectId( bd ) );
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDoGetAccess/createExisting !", e, usr, "Get", null, "org.webdocwf.util.genericstore.data.AttributeBoolValueDO", null, null, null, null, null);
	}
	return usr.hasDOGetAccess( newDO );
    }
// end of WebDocWf extension for DODS row instance security

    /**
     * The createExisting method is used to create a <CODE>AttributeBoolValueDO</CODE>
     * from a string handle.
     */
    public static AttributeBoolValueDO createExisting( String handle ) {
	AttributeBoolValueDO ret = null;
        try {
            BigDecimal bd = new BigDecimal( handle );
	    ret = createExisting( bd );
        } catch ( Exception e ) {
        }
	return ret;
    }
// WebDocWf extension for DODS row instance security
// The following lines have been added:
    /**
     * The createExisting method is used to create a <CODE>AttributeBoolValueDO</CODE>
     * from a string handle.
     *   
     * WebDocWf extension
     *   
     */
    public static AttributeBoolValueDO createExisting( String handle, org.webdocwf.dods.access.User usr )
    throws AccessException
    {
	AttributeBoolValueDO ret = createExisting( handle );
        if (ret!=null)
        {
          ret.assertDOGetAccess( usr );
        }
	return ret;
    }
    /**
     * Check whether the given user is allowed to read the DO existance
     * Static function to be called without having the object
     *
     * @param handle The string representation of the ObjectId for the object.
     * @param usr The user for security check
     * @return Whether the given user is allowed to read the DO existance
     *   
     * WebDocWf extension
     *   
     */
    public static boolean hasDOGetAccess( String handle, org.webdocwf.dods.access.User usr ) throws AccessEvalException {
	AttributeBoolValueDO newDO;
	try {
	  newDO = createExisting( handle );
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDoGetAccess/createExisting !", e, usr, "Get", null, "org.webdocwf.util.genericstore.data.AttributeBoolValueDO", null, null, null, null, null);
	}
	return usr.hasDOGetAccess( newDO );
    }
// end of WebDocWf extension for DODS row instance security

    /**
     * createExisting( ObjectId )
     *
     * Factory method creates a AttributeBoolValueDO object by searching for it
     * in the database using the passed ObjectID value as the primary key.
     *
     * @param id The ObjectId for the object.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected static AttributeBoolValueDO createExisting( ObjectId id )
    throws SQLException, ObjectIdException, DataObjectException, DatabaseManagerException
    {
	if ( null == id )
	    return null;
	AttributeBoolValueDO ret = null;
	ret = new AttributeBoolValueDO( id );
	ret.setPersistent( true );  // mark DO as persistent (preexisting)
	if ( ! false ) // If not lazy-loading, fetch DO data now.
	    ret.loadData();
// WebDocWf fix for thread safe lazyloading
// The following lines have been put under comments:
// end of WebDocWf fix for thread safe lazyloading
	// unset the GenericDO.dirty flag.
	ret.markClean();
	return ret;
    }

    /**
     * createExisting( ResultSet )
     *
     * Factory method used to create an instance of this class to
     * represent a Data Object already existing in the database.
     *
     * @param rs The ResultSet returned by the Query class for
     * an existing Data Object stored in the database.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected static AttributeBoolValueDO createExisting( ResultSet rs )
    throws SQLException, ObjectIdException, DataObjectException
		, DatabaseManagerException
    {
	if ( null == rs )
	    return null;
	AttributeBoolValueDO ret = null;
	if ( isView ) {
	    ret = new AttributeBoolValueDO ();
	    ret.initFromResultSet( rs );
	} else {
	    ret = new AttributeBoolValueDO ( rs );
	}
// WebDocWf fix for thread safe lazyloading
// The following lines have been put under comments:
// end of WebDocWf fix for thread safe lazyloading
	return ret;
    }

    /**
     * createExisting( RDBRow )
     *
     * Factory method creates a AttributeBoolValueDO object by searching for it
     * in the database using the AttributeBoolValueDO.PrimaryKey value
     * in the passed RDBRow.
     *
     * @param RDBRow A row returned by QueryBuilder.getNextRow().
     *
     * @exception DataObjectException
     *   If the RDBRow does not contain a AttributeBoolValueDO.PrimaryKey.
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected static AttributeBoolValueDO createExisting( RDBRow row )
    throws SQLException, ObjectIdException, DataObjectException
		, DatabaseManagerException
    {
	if ( null == row )
	    return null;
        RDBColumnValue pk = null;
        try {
	    pk = row.get( AttributeBoolValueDO.PrimaryKey );
	    return createExisting( pk );
        } catch ( Exception e ) {
	    throw new DataObjectException(
		"Cannot create AttributeBoolValueDO, row does not " +
		"contain AttributeBoolValueDO primary key." );
        }
    }

    /**
     * createExisting( RDBColumnValue )
     *
     * Factory method creates a AttributeBoolValueDO object by searching for it
     * in the database using the passed AttributeBoolValueDO.PrimaryKey.
     *
     * @param RDBColumnValue a PrimaryKey column value from a row
     * that was returned by QueryBuilder.getNextRow().
     *
     * @exception DataObjectException
     *   If the RDBColumnValue does not contain a AttributeBoolValueDO.PrimaryKey.
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected static AttributeBoolValueDO createExisting( RDBColumnValue pk )
    throws SQLException, ObjectIdException, DataObjectException
		, DatabaseManagerException
    {
	if ( null == pk )
	    return null;
	if ( ! pk.equals( AttributeBoolValueDO.PrimaryKey ) )
	    throw new DataObjectException(
		"Cannot create AttributeBoolValueDO, " +
		"RDBColumnValue is not AttributeBoolValueDO.PrimaryKey." );
	BigDecimal bd = null;
        try {
	    bd = pk.getBigDecimal();
        } catch ( Exception e ) {
	    throw new DataObjectException(
		"Cannot create AttributeBoolValueDO, bad primary key." );
        }
	if ( null == bd )
            return null;
	return createExisting( bd );
    }

    /**
     * createCopy()
     * Creates a DO that has no ObjectId
     * but has a copy of an existing DO's data.
     * Such a DO is used to insert a new database entry
     * that is largely similar to an existing entry.
     *
     * @param data The data struct to copy values from.
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     */
    public static AttributeBoolValueDO createCopy( AttributeBoolValueDataStruct data )
    throws DatabaseManagerException, ObjectIdException {
	AttributeBoolValueDO ret = new AttributeBoolValueDO ();
	ret.data = ( AttributeBoolValueDataStruct ) data.duplicate();
	return ret;
    }

    /**
     * createCopy()
     * Creates a DO that has no ObjectId
     * but has a copy of an existing DO's data.
     * Such a DO is used to insert a new database entry
     * that is largely similar to an existing entry.
     *
     * @param orig The original DO to copy.
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     */
    public static AttributeBoolValueDO createCopy( AttributeBoolValueDO orig )
    throws DatabaseManagerException, ObjectIdException {
	AttributeBoolValueDO ret = new AttributeBoolValueDO ();
	if ( null != orig.data ) {
	    ret.data = ( AttributeBoolValueDataStruct ) orig.data.duplicate();
	}
	return ret;
    }
// WebDocWf extension for DODS row instance security
// The following lines have been added:
    /**
     * createCopy()
     * Creates a DO that has no ObjectId
     * but has a copy of an existing DO's data.
     * Such a DO is used to insert a new database entry
     * that is largely similar to an existing entry.
     *
     * @param orig The original DO to copy.
     * @param usr The user for security check
     *
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception AccessException
     *   The user is not allowed to make a copy
     *
     * WebDocWf extension
     *
     */
    public static AttributeBoolValueDO createCopy( AttributeBoolValueDO orig, org.webdocwf.dods.access.User usr )
    throws DatabaseManagerException, ObjectIdException, AccessException {
        orig.assertDOCopyAccess ( usr );
	AttributeBoolValueDO ret = createCopy ( orig );
	return ret;
    }
// end of WebDocWf extension for DODS row instance security

    /**
     * reload()
     * Causes the DO to refresh itself from the database
     * the next time a set or get method is called.
     */
    public void reload() {
	data = null;
    }


    /**
     * The methods <CODE>
     *     getHandle
     *     hasMatchingHandle
     * </CODE> are used by Presentation Objects that need to populate
     * HTML select lists with Data Objects as options.
     * The <CODE>getHandle()</CODE> method is used
     * to set the value for each option,
     * and the <CODE>hasMatchingHandle()<CODE>
     * methods are used to lookup the Data Object when the selection has
     * been made.
     *
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     *
     * @return id of this DO as a string
     *   If an object id can't be allocated for this object.
     */
    public        String  getHandle()
    throws DatabaseManagerException {
	String ret = null;
	    if ( null == getOId() )
		   throw new DatabaseManagerException( "ID not set" );
	    ret = getOId().toString();
        return ret;
    }

   /**
     * hasMatchingHandle
     *
     * @param handle
     *   <CODE>String</CODE> version of DO id
     * @return boolean
     *   True if the string version of the id of this DO matches passed handle
     */
    public        boolean hasMatchingHandle( String handle ) {
	boolean ret = false;
	    if ( null == getOId() )
		   ret = false;
	    else
		   ret = getOId().toString().equals( handle );
        return ret;
    }



    /**
     * makeIdentical()
     *
     * Assigns the DataStruct of an existing DO to this DO.
     * Does not duplicate data. Just assigns the reference.
     *
     * @param orig The original DO.
     *
     */
    protected void makeIdentical( AttributeBoolValueDO orig ) {
	super.makeIdentical(orig);
	data = orig.data;
    }
// WebDocWf extension for writeable fully cached obejcts
    /**
     * makeReadOnly()
     * Mark the object as readonly
     * 
     * WebDocWf extension
     * 
     */
    public void makeReadOnly() {
	if ( null != data ) data.readOnly=true;
    }
    /**
     * Mark the object as readwrite
     * 
     * WebDocWf extension
     * 
     */
    /**
     * makeReadWrite()
     */
    public void makeReadWrite() {
	if ( null != data ) data.readOnly=false;
    }
// end of WebDocWf extension for writeable fully cached obejcts

////////////////////////// data member ATTRIBUTEDEFINITIONOID

   
   /* static final RDBColumn ATTRIBUTEDEFINITIONOID for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn ATTRIBUTEDEFINITIONOID = 
		new RDBColumn( table, "ATTRIBUTEDEFINITIONOID", true );

   
   

   /**
    * Get ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    *
    * @return ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public org.webdocwf.util.genericstore.data.AttributeDefinitionDO getATTRIBUTEDEFINITIONOID () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.ATTRIBUTEDEFINITIONOID;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    *
    * @param usr The user for security check
    * @return ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public org.webdocwf.util.genericstore.data.AttributeDefinitionDO getATTRIBUTEDEFINITIONOID ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrATTRIBUTEDEFINITIONOIDAccess( usr );
      org.webdocwf.util.genericstore.data.AttributeDefinitionDO ret = getATTRIBUTEDEFINITIONOID();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO:ATTRIBUTEDEFINITIONOID", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrATTRIBUTEDEFINITIONOIDAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrATTRIBUTEDEFINITIONOIDAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "ATTRIBUTEDEFINITIONOID", null, null, "org.webdocwf.util.genericstore.data.AttributeDefinitionDO", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrATTRIBUTEDEFINITIONOIDAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO:ATTRIBUTEDEFINITIONOID", data.ATTRIBUTEDEFINITIONOID, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueATTRIBUTEDEFINITIONOIDAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	org.webdocwf.util.genericstore.data.AttributeDefinitionDO val;
	try {
        val = getATTRIBUTEDEFINITIONOID();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueATTRIBUTEDEFINITIONOIDAccess/getATTRIBUTEDEFINITIONOID !", e, usr, "GetAttr", this, null, "ATTRIBUTEDEFINITIONOID", null, null, "org.webdocwf.util.genericstore.data.AttributeDefinitionDO", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    *
    * @param ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setATTRIBUTEDEFINITIONOID ( org.webdocwf.util.genericstore.data.AttributeDefinitionDO ATTRIBUTEDEFINITIONOID )
   throws DataObjectException {
      checkLoad();
      data.ATTRIBUTEDEFINITIONOID = (org.webdocwf.util.genericstore.data.AttributeDefinitionDO) markNewValue(
	data.ATTRIBUTEDEFINITIONOID, ATTRIBUTEDEFINITIONOID  );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    *
    * @param ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setATTRIBUTEDEFINITIONOID ( org.webdocwf.util.genericstore.data.AttributeDefinitionDO ATTRIBUTEDEFINITIONOID, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrATTRIBUTEDEFINITIONOIDAccess( ATTRIBUTEDEFINITIONOID, usr );
      setATTRIBUTEDEFINITIONOID( ATTRIBUTEDEFINITIONOID );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrATTRIBUTEDEFINITIONOIDAccess( org.webdocwf.util.genericstore.data.AttributeDefinitionDO ATTRIBUTEDEFINITIONOID, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrATTRIBUTEDEFINITIONOIDAccess( ATTRIBUTEDEFINITIONOID, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "ATTRIBUTEDEFINITIONOID", null, null, "org.webdocwf.util.genericstore.data.AttributeDefinitionDO", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param ATTRIBUTEDEFINITIONOID of the ATTRIBUTEBOOLVALUE
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrATTRIBUTEDEFINITIONOIDAccess( org.webdocwf.util.genericstore.data.AttributeDefinitionDO ATTRIBUTEDEFINITIONOID, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrATTRIBUTEDEFINITIONOIDAccess/checkLoad !", e, usr, "SetAttr", this, null, "ATTRIBUTEDEFINITIONOID", null, null, "org.webdocwf.util.genericstore.data.AttributeDefinitionDO", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO:ATTRIBUTEDEFINITIONOID", data.ATTRIBUTEDEFINITIONOID,ATTRIBUTEDEFINITIONOID,usr );
   }
// end of WebDocWf extension for DODS row instance security
   


////////////////////////// data member BOOLVALUE

   
   /* static final RDBColumn BOOLVALUE for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn BOOLVALUE = 
		new RDBColumn( table, "BOOLVALUE", true );

   
   

   /**
    * Get BOOLVALUE of the ATTRIBUTEBOOLVALUE
    *
    * @return BOOLVALUE of the ATTRIBUTEBOOLVALUE
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public boolean getBOOLVALUE () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.BOOLVALUE;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get BOOLVALUE of the ATTRIBUTEBOOLVALUE
    *
    * @param usr The user for security check
    * @return BOOLVALUE of the ATTRIBUTEBOOLVALUE
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public boolean getBOOLVALUE ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrBOOLVALUEAccess( usr );
      boolean ret = getBOOLVALUE();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO:BOOLVALUE", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrBOOLVALUEAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrBOOLVALUEAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "BOOLVALUE", null, null, "boolean", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrBOOLVALUEAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO:BOOLVALUE", data.BOOLVALUE, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueBOOLVALUEAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	boolean val;
	try {
        val = getBOOLVALUE();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueBOOLVALUEAccess/getBOOLVALUE !", e, usr, "GetAttr", this, null, "BOOLVALUE", null, null, "boolean", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set BOOLVALUE of the ATTRIBUTEBOOLVALUE
    *
    * @param BOOLVALUE of the ATTRIBUTEBOOLVALUE
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setBOOLVALUE ( boolean BOOLVALUE )
   throws DataObjectException {
      checkLoad();
      data.BOOLVALUE =  markNewValue(
	data.BOOLVALUE, BOOLVALUE  );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set BOOLVALUE of the ATTRIBUTEBOOLVALUE
    *
    * @param BOOLVALUE of the ATTRIBUTEBOOLVALUE
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setBOOLVALUE ( boolean BOOLVALUE, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrBOOLVALUEAccess( BOOLVALUE, usr );
      setBOOLVALUE( BOOLVALUE );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param BOOLVALUE of the ATTRIBUTEBOOLVALUE
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrBOOLVALUEAccess( boolean BOOLVALUE, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrBOOLVALUEAccess( BOOLVALUE, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "BOOLVALUE", null, null, "boolean", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param BOOLVALUE of the ATTRIBUTEBOOLVALUE
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrBOOLVALUEAccess( boolean BOOLVALUE, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrBOOLVALUEAccess/checkLoad !", e, usr, "SetAttr", this, null, "BOOLVALUE", null, null, "boolean", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO:BOOLVALUE", data.BOOLVALUE,BOOLVALUE,usr );
   }
// end of WebDocWf extension for DODS row instance security
   


////////////////////////// data member GENERICOBJECTOID

   
   /* static final RDBColumn GENERICOBJECTOID for use with QueryBuilder.
    * See RDBColumn PrimaryKey at the top of this file for usage example.
    */
   static public final RDBColumn GENERICOBJECTOID = 
		new RDBColumn( table, "GENERICOBJECTOID", true );

   
   

   /**
    * Get GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    *
    * @return GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public org.webdocwf.util.genericstore.data.GenericObjectDO getGENERICOBJECTOID () 
   throws DataObjectException {
   
      checkLoad();
   
      return data.GENERICOBJECTOID;
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Get GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    *
    * @param usr The user for security check
    * @return GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public org.webdocwf.util.genericstore.data.GenericObjectDO getGENERICOBJECTOID ( org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOGetAttrGENERICOBJECTOIDAccess( usr );
      org.webdocwf.util.genericstore.data.GenericObjectDO ret = getGENERICOBJECTOID();
      assertDOGetDOValueAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO:GENERICOBJECTOID", ret, usr );
      return ret;
   }
   /**
    * Ensure that the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOGetAttrGENERICOBJECTOIDAccess( org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOGetAttrGENERICOBJECTOIDAccess( usr )) throw new AccessRightException( "No access", usr, "GetAttr", this, null, "GENERICOBJECTOID", null, null, "org.webdocwf.util.genericstore.data.GenericObjectDO", null);
   }

   /**
    * Check whether the given user is allowed to read the attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetAttrGENERICOBJECTOIDAccess( org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	return hasDOGetAttrAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO:GENERICOBJECTOID", data.GENERICOBJECTOID, usr );
   }
   /**
    * Check whether the given user is allowed to read object in a pointer attribute
    *
    * @param usr The user for security check
    * @return Whether the given user is allowed to read the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOGetDOValueGENERICOBJECTOIDAccess ( org.webdocwf.dods.access.User usr ) 
   throws AccessEvalException {
	org.webdocwf.util.genericstore.data.GenericObjectDO val;
	try {
        val = getGENERICOBJECTOID();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOGetDOValueGENERICOBJECTOIDAccess/getGENERICOBJECTOID !", e, usr, "GetAttr", this, null, "GENERICOBJECTOID", null, null, "org.webdocwf.util.genericstore.data.GenericObjectDO", null);
	}
      return hasDOGetDOValueAccess(val, usr);
   }
// end of WebDocWf extension for DODS row instance security

   
   /**
    * Set GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    *
    * @param GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setGENERICOBJECTOID ( org.webdocwf.util.genericstore.data.GenericObjectDO GENERICOBJECTOID )
   throws DataObjectException {
      checkLoad();
      data.GENERICOBJECTOID = (org.webdocwf.util.genericstore.data.GenericObjectDO) markNewValue(
	data.GENERICOBJECTOID, GENERICOBJECTOID  );
   }
// WebDocWf extension for DODS row instance security
// The following lines have been added
   /**
    * Set GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    *
    * @param GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    * @param usr The user for security check
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void setGENERICOBJECTOID ( org.webdocwf.util.genericstore.data.GenericObjectDO GENERICOBJECTOID, org.webdocwf.dods.access.User usr ) 
   throws DataObjectException, AccessException {
      assertDOSetAttrGENERICOBJECTOIDAccess( GENERICOBJECTOID, usr );
      setGENERICOBJECTOID( GENERICOBJECTOID );
   }
   /**
    * Ensure that the given user is allowed to update the attribute
    *
    * @param GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    * @param usr The user for security check
    *
    * @exception AccessException
    *   The user is not allowed to read the attribute(value)
    *
    * WebDocWf extension
    *
    */
   public void assertDOSetAttrGENERICOBJECTOIDAccess( org.webdocwf.util.genericstore.data.GenericObjectDO GENERICOBJECTOID, org.webdocwf.dods.access.User usr )
   throws AccessException {
	if (!hasDOSetAttrGENERICOBJECTOIDAccess( GENERICOBJECTOID, usr )) throw new AccessRightException( "No access", usr, "SetAttr", this, null, "GENERICOBJECTOID", null, null, "org.webdocwf.util.genericstore.data.GenericObjectDO", null);
   }
   /**
    * Check whether the given user is allowed to update the attribute
    *
    * @param GENERICOBJECTOID of the ATTRIBUTEBOOLVALUE
    * @param usr The user for security check
    * @return Whether the given user is allowed to update the attribute
    *
    * WebDocWf extension
    *
    */
   public boolean hasDOSetAttrGENERICOBJECTOIDAccess( org.webdocwf.util.genericstore.data.GenericObjectDO GENERICOBJECTOID, org.webdocwf.dods.access.User usr)
   throws AccessEvalException {
	try {
	checkLoad();
	} catch (Exception e)
	{
	  throw new AccessEvalException("Error in hasDOSetAttrGENERICOBJECTOIDAccess/checkLoad !", e, usr, "SetAttr", this, null, "GENERICOBJECTOID", null, null, "org.webdocwf.util.genericstore.data.GenericObjectDO", null);
	}
	return hasDOSetAttrAccess( "org.webdocwf.util.genericstore.data.AttributeBoolValueDO:GENERICOBJECTOID", data.GENERICOBJECTOID,GENERICOBJECTOID,usr );
   }
// end of WebDocWf extension for DODS row instance security
   

    /**
     * Protected constructor.
     *
     * @param rs
     *   Result set from which to obtain product data.
     *
     * @exception DataObjectException
     *   If the object is not found in the database.
     * @exception com.lutris.appserver.server.sql.ObjectIdException
     *   If an object id can't be allocated for this object.
     * @exception DatabaseManagerException
     *   If a connection to the database cannot be established, etc.
     * @exception SQLException
     *   If the database rejects the SQL generated to retrieve data
     *   for this object, or if the table contains a bad foreign key, etc.
     */
    protected AttributeBoolValueDO(ResultSet rs)
            throws SQLException, ObjectIdException, DataObjectException
 	    , DatabaseManagerException
    {
        super(rs);
	initFromResultSet( rs );
//	super.init( rs );
    }

    /**
     * initFromResultSet initializes the data members from ATTRIBUTEBOOLVALUE.
     * This code was separated from the ResultSet constructor
     * so that createExisting(ResultSet) could handle VIEWs.
     */
    private void initFromResultSet( ResultSet rs )
            throws SQLException, ObjectIdException, DataObjectException
 	    , DatabaseManagerException
    {
	// Constructing a DO from a ResultSet means we definitely need the 
	// DataStruct ready for the setXxx methods invoked below.
	data = new AttributeBoolValueDataStruct ();
 
	// writeMemberStuff uses the ResultSetExtraction.template
	// to build up the value for this tag:
	// the value is a series of calls to the DO set methods.

	
	setATTRIBUTEDEFINITIONOID( 
	    org.webdocwf.util.genericstore.data.AttributeDefinitionDO.createExisting( 
		rs.getBigDecimal( 
// WebDocWf bug fix
// The following line has been changed:
			"ATTRIBUTEDEFINITIONOID" )
// before: "ATTRIBUTEDEFINITIONOID" , 0 )
// end of WebDocWf bug fix
	     )
	);
	
	
	setBOOLVALUE( 
	    
		rs.getBoolean( 
// WebDocWf bug fix
// The following line has been changed:
			"BOOLVALUE" )
// before: "BOOLVALUE" , 0 )
// end of WebDocWf bug fix
	    
	);
	
	
	setGENERICOBJECTOID( 
	    org.webdocwf.util.genericstore.data.GenericObjectDO.createExisting( 
		rs.getBigDecimal( 
// WebDocWf bug fix
// The following line has been changed:
			"GENERICOBJECTOID" )
// before: "GENERICOBJECTOID" , 0 )
// end of WebDocWf bug fix
	     )
	);
	

 
        markClean();
    }        


    

    

    private int[] param = null;

    /**
     * Prepares the statement used to insert this object
     * into the database.
     * @param conn the database connection.
     * @return the insert statement.
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getInsertStatement(DBConnection conn)
            throws SQLException {
	/* 
	 * It would probably be better to have CoreDO implement
	 * 	void addToCache(CoreDO DO) {}
	 * and have each DO that has caching enabled override it as
	 *      void addToCache(CoreDO DO) { cache.put( DO.getOId(), DO ); }
	 * and change CoreDO to invoke addToCache()
	 * when it invokes getInsertStatement().
	 */

        ObjectId oid;

        PreparedStatement stmt = conn.prepareStatement( 
	    "insert into ATTRIBUTEBOOLVALUE ( ATTRIBUTEDEFINITIONOID, BOOLVALUE, GENERICOBJECTOID, " + getOIdColumnName() + ", " + getVersionColumnName() + " ) values ( ?, ?, ?, ?, ? )" );

	param = new int[1]; param[0] = 1;
	// writeMemberStuff uses the JDBCsetCalls.template
	// to build up the value for this tag:
	// the value is a series of calls to setPrepStmtParam_TYPE methods.
	// Those methods are defined in GenericDO.
	try {
	    setPrepStmtParam_DO( stmt, param,
		getATTRIBUTEDEFINITIONOID() );
	    setPrepStmtParam_boolean( stmt, param,
		getBOOLVALUE() );
	    setPrepStmtParam_DO( stmt, param,
		getGENERICOBJECTOID() );


	    /* The ObjecId/Version columns form the primary key.  */
	    setPrepStmtParam_BigDecimal( stmt, param, getOId().toBigDecimal() );
	    setPrepStmtParam_int(        stmt, param, getNewVersion() );

	} catch ( Exception e ) {
	    throw new SQLException( "Data Object error: " + e.getMessage() );
	}

        return stmt;
    }

    /**
     * Prepares the statement used to update this object
     * in the database.
     * @param conn the database connection
     * @return the update statement.
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getUpdateStatement(DBConnection conn)
            throws SQLException {

        ObjectId oid;

        PreparedStatement stmt = conn.prepareStatement(
	    "update ATTRIBUTEBOOLVALUE set " + getVersionColumnName() + " = ?, ATTRIBUTEDEFINITIONOID = ?, BOOLVALUE = ?, GENERICOBJECTOID = ? " +
	    "where " + getOIdColumnName() + " = ? and " + getVersionColumnName() + " = ?" );

	param = new int[1]; param[0] = 1;
	//int[] param = {1};
	// writeMemberStuff builds up the value for this tag:
	// the value is a series of calls to setPrepStmtParam_TYPE methods.
	// Those methods are defined below.
	try {
	    setPrepStmtParam_int( stmt, param, getNewVersion() );
	    setPrepStmtParam_DO( stmt, param,
		getATTRIBUTEDEFINITIONOID() );
	    setPrepStmtParam_boolean( stmt, param,
		getBOOLVALUE() );
	    setPrepStmtParam_DO( stmt, param,
		getGENERICOBJECTOID() );


	    /* When updating a persistent object, the UPDATE_WHERE_CLAUSE tag
	     * used to build the SQL WHERE clause (above) uses the 
	     * DO's ObjectId and Version to locate the correct row in
	     * the database table.
	     */
	    setPrepStmtParam_BigDecimal( stmt, param, getOId().toBigDecimal() );
	    setPrepStmtParam_int(        stmt, param, getVersion() );

	} catch ( Exception e ) {
	    throw new SQLException( "Data Object error: " + e.getMessage() );
	}

        return stmt;
    }

    /**
     * Prepares the statement used to delete this object
     * from the database.
     * @param conn the database connection
     * @return the delete statement.
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getDeleteStatement(DBConnection conn)
            throws SQLException {

        String sql =
            "delete from ATTRIBUTEBOOLVALUE \n" +
            "where " + getOIdColumnName() + " = ?";
        PreparedStatement stmt = conn.prepareStatement(sql);
        stmt.setBigDecimal(1, getOId().toBigDecimal());
        return stmt;
    }

    

    /*
     * toString - for debugging
     */
/*
    public String toString(){
	String str = "AttributeBoolValueDO:";
	ObjectId oid = getOId();
	String id = "virgin";
	if ( null != oid ) 
	    id = oid.toString();
	str += " OID=" + id;
	if ( null != data ) 
	    str = str + "\n" + indent + "ATTRIBUTEDEFINITIONOID=" + ( null == data.ATTRIBUTEDEFINITIONOID ? null  : data.ATTRIBUTEDEFINITIONOID.toString( indentCount + 1 ) )
+ "\n" + indent + "BOOLVALUE=" + data.BOOLVALUE
+ "\n" + indent + "GENERICOBJECTOID=" + ( null == data.GENERICOBJECTOID ? null  : data.GENERICOBJECTOID.toString( indentCount + 1 ) )
;
        return str + "; " + super.toString();
    }
*/

    /*
     * toString - for debugging
     */
    public String toString(){
        return toString( 1 );
    }
    public String toString( int indentCount ){
        String indent = "";
        for ( int i = 0; i < indentCount; i++ ) {
            indent += ". ";
        }
        String str = indent + "AttributeBoolValueDO:";
        ObjectId oid = getOId();
        String id = "virgin";
        if ( null != oid )
            id = oid.toString();
        str += " OID=" + id;
        if ( null != data )
            str = str + "\n" + indent + "ATTRIBUTEDEFINITIONOID=" + ( null == data.ATTRIBUTEDEFINITIONOID ? null  : data.ATTRIBUTEDEFINITIONOID.toString( indentCount + 1 ) )
+ "\n" + indent + "BOOLVALUE=" + data.BOOLVALUE
+ "\n" + indent + "GENERICOBJECTOID=" + ( null == data.GENERICOBJECTOID ? null  : data.GENERICOBJECTOID.toString( indentCount + 1 ) )
;
        return str + "\n" + indent + "SUPER=" + super.toString( indentCount );
        //return str;
    }

    



    /**
     * A stub method for implementing pre-commit assertions 
     * for this AttributeBoolValueDO.
     * Implement this stub to throw an RefAssertionException for cases
     * where this object is not valid for writing to the database.
     */
    protected void okToCommit() 
    throws RefAssertionException { }

    /**
     * A stub method for implementing pre-delete assertions 
     * for this AttributeBoolValueDO.
     * Implement this stub to throw an RefAssertionException for cases
     * where this object is not valid for deletion from the database.
     */
    protected void okToDelete() 
    throws RefAssertionException { }

  /**
   * Inserts/Updates the DO into its table.
   *
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * @deprecated Use save() instead.
   */
  public void commit() 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following line was put under comments
//    modifyDO( null, false );
// The following lines have been inserted:
    DBTransaction dbt = DODS.getDatabaseManager().createTransaction();

    save(dbt);
    dbt.commit();
    dbt.release();
// end of WebDocWf extension for generic store
  }

  /**
   * Inserts/Updates the DO into its table.
   *
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
  public void save() 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
	save(true);
  }

  /**
   * Inserts/Updates the DO into its table.
   *
   * @param references True if references should be saved with this DO
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
  public void save(boolean references) 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following line was put under comments
//    modifyDO( null, false, references );
// The following lines have been inserted:
    DBTransaction dbt = DODS.getDatabaseManager().createTransaction();

    save(dbt, references);
    dbt.commit();
    dbt.release();
// end of WebDocWf extension for generic store
  }

  /**
   * Inserts/Updates the DO into its table.
   * The transaction is likely provided by the commit() method of another DO
   * which references this DO.
   * 
   * @param dbt The transaction object to use for this operation.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * @deprecated Use save() instead.
   */
  public void commit(DBTransaction dbt)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following line has been inserted:
    DBTransaction dbtlocal = dbt;
    if (dbtlocal == null) dbtlocal = DODS.getDatabaseManager().createTransaction();
// The following line has been changed:
    modifyDO( dbtlocal, false );
// before: modifyDO( dbt, false );
// The following line has been inserted:
    super.save(dbtlocal);
// end of WebDocWf extension for generic store
  }

  /**
   * Inserts/Updates the DO into its table.
   * The transaction is likely provided by the commit() method of another DO
   * which references this DO.
   * 
   * @param dbt The transaction object to use for this operation.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
  public void save(DBTransaction dbt)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
	save(dbt, true);
  }

  /**
   * Inserts/Updates the DO into its table.
   * The transaction is likely provided by the commit() method of another DO
   * which references this DO.
   * 
   * @param dbt The transaction object to use for this operation.
   * @param references True if references of this DO should be saved
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
  public void save(DBTransaction dbt, boolean references)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following line has been inserted:
    DBTransaction dbtlocal = dbt;
    if (dbtlocal == null) dbtlocal = DODS.getDatabaseManager().createTransaction();
// The following line has been changed:
    modifyDO( dbtlocal, false, references );
// before: modifyDO( dbt, false );
// The following line has been inserted:
    super.save(dbtlocal);
// end of WebDocWf extension for generic store
  }

  /**
   * Deletes the DO from its table.
   *
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   */
  public void delete() 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {

// WebDocWf extension for generic store
// The following line was put under comments
//    modifyDO( null, true );
// The following lines have been inserted:
    DBTransaction dbt = DODS.getDatabaseManager().createTransaction();
    delete(dbt);
    dbt.commit();
    dbt.release();
// end of WebDocWf extension for generic store
  }

  /**
   * Deletes the DO from its table.
   * The transaction is likely provided by the delete() method of another DO
   * which references this DO.
   *
   * @param dbt The transaction object to use for this operation.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   */
  public void delete(DBTransaction dbt)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
// WebDocWf extension for generic store
// The following lines have been inserted:
    DBTransaction dbtlocal = dbt;
    if (dbtlocal == null) dbtlocal = DODS.getDatabaseManager().createTransaction();
    super.delete(dbtlocal);
// The following line has been changed:
    modifyDO( dbtlocal, true );
// before:    modifyDO( dbt, true );
// end of WebDocWf extension for generic store
  }

      /**
     * A stub method for implementing pre-commit assertions 
     * for the ATTRIBUTEDEFINITIONOID data member.
     * Implement this stub to throw an RefAssertionException for cases
     * where ATTRIBUTEDEFINITIONOID is not valid for writing to the database.
     */
    protected void okToCommitATTRIBUTEDEFINITIONOID( org.webdocwf.util.genericstore.data.AttributeDefinitionDO member ) 
    throws RefAssertionException { }

    /**
     * A stub method for implementing pre-delete assertions 
     * for the ATTRIBUTEDEFINITIONOID data member.
     * Implement this stub to throw an RefAssertionException for cases
     * where ATTRIBUTEDEFINITIONOID is not valid for deletion from the database.
     */
    protected void okToDeleteATTRIBUTEDEFINITIONOID( org.webdocwf.util.genericstore.data.AttributeDefinitionDO member ) 
    throws RefAssertionException { }

    /**
     * A stub method for implementing pre-commit assertions 
     * for the GENERICOBJECTOID data member.
     * Implement this stub to throw an RefAssertionException for cases
     * where GENERICOBJECTOID is not valid for writing to the database.
     */
    protected void okToCommitGENERICOBJECTOID( org.webdocwf.util.genericstore.data.GenericObjectDO member ) 
    throws RefAssertionException { }

    /**
     * A stub method for implementing pre-delete assertions 
     * for the GENERICOBJECTOID data member.
     * Implement this stub to throw an RefAssertionException for cases
     * where GENERICOBJECTOID is not valid for deletion from the database.
     */
    protected void okToDeleteGENERICOBJECTOID( org.webdocwf.util.genericstore.data.GenericObjectDO member ) 
    throws RefAssertionException { }



  /**
   * Modifies the DO within its table.
   * Performs recursive commit/delete on referenced DOs;
   * all operations occur within a single transaction
   * to allow rollback in the event of error.
   * Only the creator of the transaction releases it.
   *
   * @param dbt The transaction object to use for this operation.
   * @param delete True if doing a delete, otherwise doing insert/update.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
// WebDocWf extension for save without references
// The following line has been modofied
  protected void modifyDO( DBTransaction dbt, boolean delete)
// before:  protected void modifyDO( DBTransaction dbt, boolean delete )
// end of WebDocWf extension for save without references
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
	modifyDO( dbt, delete, true);
  }
  /**
   * Modifies the DO within its table.
   * Performs recursive commit/delete on referenced DOs;
   * all operations occur within a single transaction
   * to allow rollback in the event of error.
   * Only the creator of the transaction releases it.
   *
   * @param dbt The transaction object to use for this operation.
   * @param delete True if doing a delete, otherwise doing insert/update.
   * @param references True if references should be saved
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * 
   * WebDocWf extension
   */
// WebDocWf extension for save without references
// The following line has been modofied
  protected void modifyDO( DBTransaction dbt, boolean delete, boolean references )
// before:  protected void modifyDO( DBTransaction dbt, boolean delete )
// end of WebDocWf extension for save without references
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException {
    if ( delete )
	okToDelete();
    else
	okToCommit();
    boolean ownTransaction = false;
    try {
      if ( null == dbt ) {
	DatabaseManager dbm = DODS.getDatabaseManager();
        dbt = dbm.createTransaction();      // create a transaction
	ownTransaction = true;
      } 
// WebDocWf fix for circular references
// The following lines have been inserted
	  else
      {
        CoreDO foundDO = dbt.getDO(this);
        if (foundDO!=null) return;
      }
// end of WebDocWf fix for circular references
      if ( null == dbt )
	throw new DatabaseManagerException(
		"DatabaseManager.createTransaction returned null." );
      if ( delete ) {
	  // Code to perform cascading deletes is generated here
	  // if cascading deletes are not supported by the database.      
	  
	  // The following line keeps the compiler happy 
	  // when the CASCADING_DELETES tag is empty.
          if ( false )
	      throw new QueryException("XXX");
      } else {
// WebDocWf extension for save without references
// The following line has been inserted
	  if (references) {
// end of WebDocWf extension for save without references
	  // commit referenced DOs.
	  	org.webdocwf.util.genericstore.data.AttributeDefinitionDO ATTRIBUTEDEFINITIONOID_DO = getATTRIBUTEDEFINITIONOID();
	if ( null != ATTRIBUTEDEFINITIONOID_DO ) {
	    if ( ATTRIBUTEDEFINITIONOID_DO.isLoaded() ) {
		okToCommitATTRIBUTEDEFINITIONOID( ATTRIBUTEDEFINITIONOID_DO );
		ATTRIBUTEDEFINITIONOID_DO.commit( dbt );
	    } else {
		// since the referenced DO is not loaded,
		// it cannot be dirty, so there is no need to commit it.
	    }
	} else {
	    if ( ! false )
		throw new RefAssertionException(
		    "Cannot commit AttributeBoolValueDO ( " + toString() +
		    " ) because ATTRIBUTEDEFINITIONOID is not allowed to be null." );
	}
	org.webdocwf.util.genericstore.data.GenericObjectDO GENERICOBJECTOID_DO = getGENERICOBJECTOID();
	if ( null != GENERICOBJECTOID_DO ) {
	    if ( GENERICOBJECTOID_DO.isLoaded() ) {
		okToCommitGENERICOBJECTOID( GENERICOBJECTOID_DO );
		GENERICOBJECTOID_DO.commit( dbt );
	    } else {
		// since the referenced DO is not loaded,
		// it cannot be dirty, so there is no need to commit it.
	    }
	} else {
	    if ( ! false )
		throw new RefAssertionException(
		    "Cannot commit AttributeBoolValueDO ( " + toString() +
		    " ) because GENERICOBJECTOID is not allowed to be null." );
	}

// WebDocWf extension for save without references
// The following line has been inserted
	  }
// end of WebDocWf extension for save without references
      }
      if ( false ) {
	  // This throw is here to keep the compiler happy
	  // in the case of a DO that does not refer to other DOs.
	  // In that case, the above delete/commit code blocks will be empty
	  // and throw nothing.
	  throw new DataObjectException( "foo" );	  
      }
      if ( delete ) {
          dbt.delete( this );
      } else {
	  if ( isLoaded() )
	      dbt.insert( this );   // dbt.insert() handles insertions and updates
      }
      if (ownTransaction) {
	  dbt.commit(); // commit the transaction
      }
    } catch (SQLException sqle) {
      StringBuffer message = new StringBuffer("Failed to insert/update DO: ");
      message.append(sqle.getMessage());

      // rollback, if necessary
      if (ownTransaction) {
        try {
          dbt.rollback();
        } catch (SQLException sqle2) {
          message.insert(0,"\n");
          message.insert(0,sqle2.getMessage());
          message.insert(0,"Rollback failed: ");
        }
      }
      throw new SQLException(message.toString());
    } finally {
      // release the transaction, if any
      if (ownTransaction) {
        dbt.release();
      }
    }
  }
}
