/*-----------------------------------------------------------------------------
 * Enhydra Java Application Server
 * Copyright 1997-2000 Lutris Technologies, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes Enhydra software developed by Lutris
 *      Technologies, Inc. and its contributors.
 * 4. Neither the name of Lutris Technologies nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY LUTRIS TECHNOLOGIES AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL LUTRIS TECHNOLOGIES OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *-----------------------------------------------------------------------------
 * C:/develop/gen/org/webdocwf/util/genericstore/data/AttributeDefinitionDOI.java
 *-----------------------------------------------------------------------------
 */

package org.webdocwf.util.genericstore.data;

import java.sql.SQLException;

import com.lutris.appserver.server.sql.DBRowUpdateException;
import com.lutris.appserver.server.sql.DBTransaction;
import com.lutris.appserver.server.sql.DatabaseManagerException;
import com.lutris.dods.builder.generator.query.DataObjectException;
import com.lutris.dods.builder.generator.query.QueryException;
import com.lutris.dods.builder.generator.query.RefAssertionException;


/**
 * Interface implemented by AttributeDefinitionDO.
 * Interface could also be implemented by a (hand-written) Business Layer class
 * which uses AttributeDefinitionDO.
 *
 * @version $Revision: 1.2 $
 * @author  administrator
 * @since   org
 */
public interface AttributeDefinitionDOI {


////////////////////////// data member KEYVALUE


   /**
    * Get KEYVALUE of the GENERICATTRIBUTEDEFINITION
    *
    * @return KEYVALUE of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getKEYVALUE () 
   throws DataObjectException;

   
   /**
    * Set KEYVALUE of the GENERICATTRIBUTEDEFINITION
    *
    * @param KEYVALUE of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setKEYVALUE ( String KEYVALUE )
   throws DataObjectException;
   


////////////////////////// data member SHORTNAME


   /**
    * Get SHORTNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @return SHORTNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getSHORTNAME () 
   throws DataObjectException;

   
   /**
    * Set SHORTNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @param SHORTNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setSHORTNAME ( String SHORTNAME )
   throws DataObjectException;
   


////////////////////////// data member LONGNAME


   /**
    * Get LONGNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @return LONGNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getLONGNAME () 
   throws DataObjectException;

   
   /**
    * Set LONGNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @param LONGNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setLONGNAME ( String LONGNAME )
   throws DataObjectException;
   


////////////////////////// data member XMLNAME


   /**
    * Get XMLNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @return XMLNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getXMLNAME () 
   throws DataObjectException;

   
   /**
    * Set XMLNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @param XMLNAME of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setXMLNAME ( String XMLNAME )
   throws DataObjectException;
   


////////////////////////// data member ATTRSCALE


   /**
    * Get ATTRSCALE of the GENERICATTRIBUTEDEFINITION
    *
    * @return ATTRSCALE of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public java.math.BigDecimal getATTRSCALE () 
   throws DataObjectException;

   
   /**
    * Set ATTRSCALE of the GENERICATTRIBUTEDEFINITION
    *
    * @param ATTRSCALE of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setATTRSCALE ( java.math.BigDecimal ATTRSCALE )
   throws DataObjectException;
   


////////////////////////// data member ATTRTYPE


   /**
    * Get ATTRTYPE of the GENERICATTRIBUTEDEFINITION
    *
    * @return ATTRTYPE of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getATTRTYPE () 
   throws DataObjectException;

   
   /**
    * Set ATTRTYPE of the GENERICATTRIBUTEDEFINITION
    *
    * @param ATTRTYPE of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setATTRTYPE ( String ATTRTYPE )
   throws DataObjectException;
   


////////////////////////// data member TRANSLATEATTR


   /**
    * Get TRANSLATEATTR of the GENERICATTRIBUTEDEFINITION
    *
    * @return TRANSLATEATTR of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public boolean getTRANSLATEATTR () 
   throws DataObjectException;

   
   /**
    * Set TRANSLATEATTR of the GENERICATTRIBUTEDEFINITION
    *
    * @param TRANSLATEATTR of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setTRANSLATEATTR ( boolean TRANSLATEATTR )
   throws DataObjectException;
   


////////////////////////// data member ATTROBJECTCLASS


   /**
    * Get ATTROBJECTCLASS of the GENERICATTRIBUTEDEFINITION
    *
    * @return ATTROBJECTCLASS of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public String getATTROBJECTCLASS () 
   throws DataObjectException;

   
   /**
    * Set ATTROBJECTCLASS of the GENERICATTRIBUTEDEFINITION
    *
    * @param ATTROBJECTCLASS of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setATTROBJECTCLASS ( String ATTROBJECTCLASS )
   throws DataObjectException;
   


////////////////////////// data member ENUMTYPEDEFINITIONOID


   /**
    * Get ENUMTYPEDEFINITIONOID of the GENERICATTRIBUTEDEFINITION
    *
    * @return ENUMTYPEDEFINITIONOID of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO getENUMTYPEDEFINITIONOID () 
   throws DataObjectException;

   
   /**
    * Set ENUMTYPEDEFINITIONOID of the GENERICATTRIBUTEDEFINITION
    *
    * @param ENUMTYPEDEFINITIONOID of the GENERICATTRIBUTEDEFINITION
    *
    * @exception DataObjectException
    *   If the object is not found in the database.
    */
   public void setENUMTYPEDEFINITIONOID ( org.webdocwf.util.genericstore.data.EnumTypeDefinitionDO ENUMTYPEDEFINITIONOID )
   throws DataObjectException;
   


  /**
   * Inserts/Updates the DO into its table.
   *
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   */
  public void save() 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException;

  /**
   * Inserts/Updates the DO into its table.
   * The transaction is likely provided by the save() method of another DO
   * which references this DO.
   * 
   * @param dbt The transaction object to use for this operation.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   */
  public void save(DBTransaction dbt)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException;

  /**
   * Inserts/Updates the DO into its table.
   *
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * @deprecated Use save() instead.
   */
  public void commit() 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException;

  /**
   * Inserts/Updates the DO into its table.
   * The transaction is likely provided by the commit() method of another DO
   * which references this DO.
   * 
   * @param dbt The transaction object to use for this operation.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   * @deprecated Use save() instead.
   */
  public void commit(DBTransaction dbt)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException;

  /**
   * Deletes the DO from its table.
   *
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   */
  public void delete() 
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException;

  /**
   * Deletes the DO from its table.
   * The transaction is likely provided by the delete() method of another DO
   * which references this DO.
   *
   * @param dbt The transaction object to use for this operation.
   * @exception com.lutris.appserver.server.sql.DatabaseManagerException if a Transaction can not be created.
   * @exception com.lutris.appserver.server.sql.DBRowUpdateException if a version error occurs.
   * @exception RefAssertionException thrown by okTo method.
   * @exception java.sql.SQLException if any SQL errors occur.
   */
  public void delete(DBTransaction dbt)
  throws SQLException, DatabaseManagerException, DataObjectException, RefAssertionException, DBRowUpdateException, QueryException;

}
