/* This SQL was generated for a MSQL database. */
create table GENERICTYPEDEFINITION
(
/* class TypeDefinition */
    KEYVALUE NVARCHAR(254) NOT NULL   ,
    SHORTNAME NVARCHAR(12) NOT NULL   ,
    LONGNAME NVARCHAR(100) NOT NULL   ,
    XMLNAME NVARCHAR(30) NOT NULL   ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);
CREATE INDEX I1_GENERICTYPEDEFINITION ON GENERICTYPEDEFINITION ( KEYVALUE );

/* This SQL was generated for a MSQL database. */
create table GENERICENUMTYPEDEFINITION
(
/* class EnumTypeDefinition */
    LONGNAME NVARCHAR(100) NOT NULL   ,
    SHORTNAME NVARCHAR(12) NOT NULL   ,
    KEYVALUE NVARCHAR(254) NOT NULL   ,
    XMLNAME NVARCHAR(30) NOT NULL   ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);

/* This SQL was generated for a MSQL database. */
create table GENERICATTRIBUTEDEFINITION
(
/* class AttributeDefinition */
    KEYVALUE NVARCHAR(254) NOT NULL   ,
    SHORTNAME NVARCHAR(12) NOT NULL   ,
    LONGNAME NVARCHAR(100) NOT NULL   ,
    XMLNAME NVARCHAR(30) NOT NULL   ,
    ATTRSCALE DECIMAL(2,0)    ,
    ATTRTYPE NVARCHAR(1) NOT NULL   ,
    TRANSLATEATTR tinyint NOT NULL   ,
    ATTROBJECTCLASS NVARCHAR(254)    ,
    ENUMTYPEDEFINITIONOID DECIMAL(19,0)   REFERENCES GENERICENUMTYPEDEFINITION ( oid ) ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);
CREATE INDEX I1_GENERICATTRIBUTEDEFINITION ON GENERICATTRIBUTEDEFINITION ( KEYVALUE );
CREATE INDEX I2_GENERICATTRIBUTEDEFINITION ON GENERICATTRIBUTEDEFINITION ( ATTRTYPE );
CREATE INDEX I3_GENERICATTRIBUTEDEFINITION ON GENERICATTRIBUTEDEFINITION ( ATTROBJECTCLASS );

/* This SQL was generated for a MSQL database. */
create table GENERICOBJECT
(
/* class GenericObject */
    EXTERNALOID DECIMAL(19,0) NOT NULL   ,
    TYPEDEFINITIONOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICTYPEDEFINITION ( oid ) ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);
CREATE INDEX I1_GENERICOBJECT ON GENERICOBJECT ( EXTERNALOID );
CREATE INDEX I2_GENERICOBJECT ON GENERICOBJECT ( TYPEDEFINITIONOID );

/* This SQL was generated for a MSQL database. */
create table GENERICENUMVALUEDEFINITION
(
/* class EnumValueDefinition */
    ENUMTYPEDEFINITIONOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICENUMTYPEDEFINITION ( oid ) ,
    BEGINSTATE tinyint    ,
    ENDSTATE tinyint    ,
    LONGNAME NVARCHAR(100) NOT NULL   ,
    SHORTNAME NVARCHAR(12) NOT NULL   ,
    KEYVALUE NVARCHAR(254) NOT NULL   ,
    XMLNAME NVARCHAR(30) NOT NULL   ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);

/* This SQL was generated for a MSQL database. */
create table ATTRIBUTEBOOLVALUE
(
/* class AttributeBoolValue */
    ATTRIBUTEDEFINITIONOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICATTRIBUTEDEFINITION ( oid ) ,
    BOOLVALUE tinyint NOT NULL   ,
    GENERICOBJECTOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICOBJECT ( oid ) ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);
CREATE INDEX I1_ATTRIBUTEBOOLVALUE ON ATTRIBUTEBOOLVALUE ( ATTRIBUTEDEFINITIONOID );
CREATE INDEX I2_ATTRIBUTEBOOLVALUE ON ATTRIBUTEBOOLVALUE ( BOOLVALUE );
CREATE INDEX I3_ATTRIBUTEBOOLVALUE ON ATTRIBUTEBOOLVALUE ( GENERICOBJECTOID );

/* This SQL was generated for a MSQL database. */
create table ATTRIBUTENUMBERVALUE
(
/* class AttributeNumberValue */
    ATTRIBUTEDEFINITIONOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICATTRIBUTEDEFINITION ( oid ) ,
    NUMBERVALUE DECIMAL(19,0) NOT NULL   ,
    GENERICOBJECTOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICOBJECT ( oid ) ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);
CREATE INDEX I1_ATTRIBUTENUMBERVALUE ON ATTRIBUTENUMBERVALUE ( ATTRIBUTEDEFINITIONOID );
CREATE INDEX I2_ATTRIBUTENUMBERVALUE ON ATTRIBUTENUMBERVALUE ( NUMBERVALUE );
CREATE INDEX I3_ATTRIBUTENUMBERVALUE ON ATTRIBUTENUMBERVALUE ( GENERICOBJECTOID );

/* This SQL was generated for a MSQL database. */
create table ATTRIBUTESTRINGVALUE
(
/* class AttributeStringValue */
    ATTRIBUTEDEFINITIONOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICATTRIBUTEDEFINITION ( oid ) ,
    STRINGVALUE NVARCHAR(254) NOT NULL   ,
    GENERICOBJECTOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICOBJECT ( oid ) ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);
CREATE INDEX I1_ATTRIBUTESTRINGVALUE ON ATTRIBUTESTRINGVALUE ( ATTRIBUTEDEFINITIONOID );
CREATE INDEX I2_ATTRIBUTESTRINGVALUE ON ATTRIBUTESTRINGVALUE ( STRINGVALUE );
CREATE INDEX I3_ATTRIBUTESTRINGVALUE ON ATTRIBUTESTRINGVALUE ( GENERICOBJECTOID );

/* This SQL was generated for a MSQL database. */
create table ATTRIBUTEENUMVALUE
(
/* class AttributeEnumValue */
    ENUMVALUEDEFINITIONOID DECIMAL(19,0)   REFERENCES GENERICENUMVALUEDEFINITION ( oid ) ,
    ATTRIBUTEDEFINITIONOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICATTRIBUTEDEFINITION ( oid ) ,
    GENERICOBJECTOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICOBJECT ( oid ) ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);

/* This SQL was generated for a MSQL database. */
create table ATTRIBUTEOBJECTVALUE
(
/* class AttributeObjectValue */
    ATTRIBUTEDEFINITIONOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICATTRIBUTEDEFINITION ( oid ) ,
    OBJECTVALUE DECIMAL(19,0) NOT NULL   ,
    GENERICOBJECTOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICOBJECT ( oid ) ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);
CREATE INDEX I1_ATTRIBUTEOBJECTVALUE ON ATTRIBUTEOBJECTVALUE ( ATTRIBUTEDEFINITIONOID );
CREATE INDEX I2_ATTRIBUTEOBJECTVALUE ON ATTRIBUTEOBJECTVALUE ( OBJECTVALUE );
CREATE INDEX I3_ATTRIBUTEOBJECTVALUE ON ATTRIBUTEOBJECTVALUE ( GENERICOBJECTOID );

/* This SQL was generated for a MSQL database. */
create table ATTRIBUTEDATEVALUE
(
/* class AttributeDateValue */
    ATTRIBUTEDEFINITIONOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICATTRIBUTEDEFINITION ( oid ) ,
    DATEVALUE datetime NOT NULL   ,
    GENERICOBJECTOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICOBJECT ( oid ) ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);
CREATE INDEX I1_ATTRIBUTEDATEVALUE ON ATTRIBUTEDATEVALUE ( ATTRIBUTEDEFINITIONOID );
CREATE INDEX I2_ATTRIBUTEDATEVALUE ON ATTRIBUTEDATEVALUE ( DATEVALUE );
CREATE INDEX I3_ATTRIBUTEDATEVALUE ON ATTRIBUTEDATEVALUE ( GENERICOBJECTOID );

/* This SQL was generated for a MSQL database. */
create table GENERICSTATETRANSITION
(
/* class StateTransition */
    ENUMVALUEDEFINITIONFROMOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICENUMVALUEDEFINITION ( oid ) ,
    ENUMVALUEDEFINITIONTOOID DECIMAL(19,0) NOT NULL  REFERENCES GENERICENUMVALUEDEFINITION ( oid ) ,
    oid DECIMAL(19,0) NOT NULL PRIMARY KEY,
    version INTEGER NOT NULL
);

create table objectid(
 next DECIMAL(19,0) NOT NULL 
);
