/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 */

/*
 *
 * @author    Nenad Vico
 * @version   1.0.0  2003/02/26
 *
 */
package org.enhydra.dods.generator;

public class DODSGenerateException extends Exception {

    /**
     * Construct a exception without a specified cause.
     *
     * @param msg The message associated with the exception.
     */
    public DODSGenerateException(String msg) {
    	super(msg);
    }

    /**
     * Construct a exception with a specified cause.
     *
     * @param cause The error or exception that cause this
     *  exception.
     */
    public DODSGenerateException(Throwable cause) {
	    super(cause);
    }

    /**
     * Construct a exception with an associated causing exception.
     *
     * @param msg The message associated with the exception.
     * @param cause The error or exception that cause this
     *  exception.
     */
    public DODSGenerateException(String msg, Throwable cause) {
        super(msg, cause);
    }

    /**
     * Creates a localized description of this Exception.
     *
     * @return the localized description of this Exception.
     */
    public String getLocalizedMessage() {
        String message = getMessage();
        int index = message.lastIndexOf(": ");
        if (index != -1) 
            return message.substring(index+1);
        else
            return getMessage();
    }

}
